$MOD51

	LCD		EQU 	P1
	EN		EQU 	P2.7
	RS		EQU 	P2.6
	SENSOR	EQU		P2.1
	

	ORG 0
INICIO:
	MOV A,#01H ;Limpa LCD
	CALL ENVIA_COMANDO
	JNB SENSOR,$
	LCALL INICIALIZAR_LCD
	MOV A,#2h ;Informa comunicacao Serial Para Manda Informacoes Tempo
	CALL TX

	;Pega Dados Da Serial
	MOV R1,#STR1
LE_SERIAL1:
	CALL RX
	CJNE A,#'$',PEGA_FRASE1
	JMP LE_SERIAL22 
PEGA_FRASE1:
	MOV @R1,A
	INC R1
	JMP LE_SERIAL1
LE_SERIAL22:
		MOV R1,#STR2
LE_SERIAL2:
	CALL RX
	CJNE A,#'$',PEGA_FRASE2
	JMP LE_SERIAL33 
PEGA_FRASE2:
	MOV @R1,A
	INC R2
	JMP LE_SERIAL2
LE_SERIAL33:
		MOV R1,#STR2
LE_SERIAL3:
	CALL RX
	CJNE A,#'$',PEGA_FRASE3
	JMP CONTINUA
PEGA_FRASE3:
	MOV @R1,A
	INC R1
	JMP LE_SERIAL3

CONTINUA:
	MOV DPTR,#STR1
	CALL TEXTO_LCD
	MOV DPTR,#STR2
	CALL TEXTO_LCD
	MOV DPTR,#STR3
	CALL ROLA
	JMP INICIO

INICIALIZAR_LCD: 
	;Configura Serial
	MOV PCON,#80h			; SMOD=1	
	MOV SCON,#74h			; SM = 01(8bits) + stop bit + enable receiver
	MOV TCON,#40h
	;Configura Timer1
	MOV TMOD,#20h			; Timer 1 Modo 2 (recarga automtica)
	MOV TH1,#243				;baute rate=4800 p/ f=12MHz
	;Configura LCD
	MOV A,#38H
	CALL ENVIA_COMANDO
	MOV A,#38H
	CALL ENVIA_COMANDO
	MOV A,#06H
	CALL ENVIA_COMANDO
	MOV A,#0CH
	CALL ENVIA_COMANDO
	MOV A,#01H
	CALL ENVIA_COMANDO
	RET

TEXTO_LCD: 
	CLR A
	MOVC A,@A+DPTR
	JZ TEXTO_FIM
	LCALL ENVIA_CHAR
	INC DPTR
	JMP TEXTO_LCD
TEXTO_FIM: 
	RET

ROLA: 
	MOV A,#0C0H
	LCALL ENVIA_COMANDO
	MOV R5,#0

ROLALOOP: 
	MOV A,R5
	MOVC A,@A+DPTR
	JZ ROLAFINAL
	INC R5
	LCALL ENVIA_CHAR
	CJNE R5,#20D,ROLALOOP
	MOV R5,#0
	INC DPTR
	LCALL ATRASO_LCD
	JMP ROLA
ROLAFINAL:
	RET

	;Funcoes
RX:		;Recebe Caractere 
	CLR RI	
	JNB RI,$
	MOV A,SBUF
	RET
TX:		;Envia Caractere
	CLR TI
	MOV SBUF,A
	JNB TI,$
	RET

ENVIA_CHAR:
	SETB RS
	JMP ENVIA
ENVIA_COMANDO:
	CLR RS
ENVIA:
	MOV LCD,A
	CLR EN
	SETB EN
	CLR EN
	RET


ATRASO_LCD: 
	MOV R7,#14H
LACO1: 
	MOV R6,#063H
	DJNZ R6,$
	DJNZ R7,LACO1
	RET

STR1: DB	'                    ',0;
STR2: DB	'                    ',0;
STR3: DB	'                                                                                      ',0;


END